/*
 * File         : test5.java
 * Author       : Guansong Zhang
 * Created      : Mon Jan 12 12:48:19 1998
 * Revision     : $Revision: 1.6 $
 * Updated      : $Date: 1998/09/29 19:48:27 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

//   integer n
//   parameter(n = 8)
//
//   real u(n, n)
//
//   !hpf$ distribute u (block, block) onto p
//   !hpf$ processors p (2, 2)
//
//   integer i, j
//   integer iter
//
//   do i = 1, n
//     do j = 1, n
//       if(i == 1 .or. i == n .or. j == 1 .or. j == n) then
//         u(i, j) = 1.0
//       else
//         u(i, j) = 0.0
//       endif
//     enddo
//   enddo
//
//   do iter = 1, 5
//     u(2 : n - 1, 2 : n - 1) = &
//                  0.25 * (u(2 : n - 1, 1 : n - 2) + u(2 : n - 1, 3 : n) + &
//                          u(1 : n - 2, 2 : n - 1) + u(3 : n, 2 : n - 1))
//     print *, "iteration =", iter
//     do i = 2, n - 1
//       print "(10f7.3)", u(i, 2 : n - 1)
//     enddo
//   enddo
//
// end

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class test5 {

  static final int n=8;

    static SpmdEnv spmd;
    static Procs2 p;
    static BlockRange x,y;
    static Array2ddF u;
    static Range xc,yc;
    static Array2ddF uLC, uRC, uCL, uCR, tmp1, tmp2, tmp3, tmp4; 
	static Index  i,j;

  public static void main(String argv[]) {
    spmd = new SpmdEnv (argv);

    p=new Procs2(2,2);

    if (p.on()) {

      x = new BlockRange (n, p.dim(0));
      y = new BlockRange (n, p.dim(1));
      
      u = new Array2ddF(spmd.apg, x, y);

      i = new Index (x);
      j = new Index (y);
      
      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
	j.dim().over();
	for (j.begin(); j.test(); j.next()) {
	  if (x.idx(i)==0 || x.idx(i)==n-1 || y.idx(j)==0 || y.idx(j)==n-1)
	    u.dat()[u.pos(i, j)]=1;
	  else
	    u.dat()[u.pos(i, j)]=0;
	} j.dim().revo();
      } i.dim().revo();
      
      xc=x.subrng(n-2, 1);      
      yc=y.subrng(n-2, 1);      

      uLC=new Array2ddF(p,x.subrng(n-2,0),u.str()[0],yc,u.str()[1],u.dat(),u.off());
      uRC=new Array2ddF(p,x.subrng(n-2,2),u.str()[0],yc,u.str()[1],u.dat(),u.off());
      uCL=new Array2ddF(p,xc,u.str()[0],y.subrng(n-2,0),u.str()[1],u.dat(),u.off());
      uCR=new Array2ddF(p,xc,u.str()[0],y.subrng(n-2,2),u.str()[1],u.dat(),u.off());
	  // Is the last parameter correct?

      // Array2Float uLC=u.section(x.subrng(n-2,0),yc);
      // Array2Float uRC=u.section(x.subrng(n-2,2),yc);
      // Array2Float uCL=u.section(xc,y.subrng(n-2,0));
      // Array2Float uCR=u.section(xc,y.subrng(n-2,2));

      tmp1= new Array2ddF(spmd.apg, xc, yc);
      tmp2= new Array2ddF(spmd.apg, xc, yc);
      tmp3= new Array2ddF(spmd.apg, xc, yc);
      tmp4= new Array2ddF(spmd.apg, xc, yc);

      for (int iter=1; iter<=5; iter++) {
	Adlib.remap(tmp1, uLC);
	Adlib.remap(tmp2, uRC);
	Adlib.remap(tmp3, uCL);
	Adlib.remap(tmp4, uCR);

	Index ic = new Index (xc);
	Index jc = new Index (yc);

	i.dim().over();
	for (ic.begin(); ic.test(); ic.next()) {
	  j.dim().over();
	  for (jc.begin(); jc.test(); jc.next()) {
	    u.dat()[u.pos(ic,jc)]
	      =(float)0.25*(tmp1.dat()[tmp1.pos(ic,jc)]+
			    tmp2.dat()[tmp2.pos(ic,jc)]+
			    tmp3.dat()[tmp3.pos(ic,jc)]+
			    tmp4.dat()[tmp4.pos(ic,jc)]);
	  } jc.dim().revo();
	} ic.dim().revo();

	//Adlib.gprintf("iteration = %d\n", iter);
	Adlib.rprintln("iteration = "+iter);
	Adlib.aprintf("%7.3f%"+n+"N", u);

      }

    } p.no();

    spmd.finalize();

  }
}
